package org.ieee1888.sample;

import java.util.Calendar;

import org.ieee1888.api.IEEE1888FetchManager;
import org.ieee1888.api.IEEE1888WriteManager;
import org.ieee1888.api.type.LimitType;
import org.ieee1888.api.type.PointDataStruct;
import org.ieee1888.utils.W3CTimestamp;

import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.app.Activity;
import android.os.Build;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends Activity {

	@SuppressWarnings("unused")
	private TextView textView1, textView2, textView3, textView4, textView5,
			textView6, textView7, textView8;
	private Button button1, button2;

	private String serverUrl = "http://10.1.1.179:1888/IEEE1888Storage";
	private String pointId = "http://biigroup.com/room/2501/VA1";

	@TargetApi(Build.VERSION_CODES.GINGERBREAD)
	@SuppressLint("NewApi")
	@Override
	protected void onCreate(Bundle savedInstanceState) {

		StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder()
				.permitAll().build();

		StrictMode.setThreadPolicy(policy);

		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		InitTextView();
		InitButton();

	}

	private void InitTextView() {
		textView1 = (TextView) findViewById(R.id.textView1);
		textView2 = (TextView) findViewById(R.id.textView2);
		textView3 = (TextView) findViewById(R.id.textView3);
		textView4 = (TextView) findViewById(R.id.textView4);
		textView5 = (TextView) findViewById(R.id.textView5);
		textView6 = (TextView) findViewById(R.id.textView6);
		textView7 = (TextView) findViewById(R.id.textView7);
		textView8 = (TextView) findViewById(R.id.textView8);
	}

	private void InitButton() {
		button1 = (Button) findViewById(R.id.writebutton);
		button2 = (Button) findViewById(R.id.fetchbutton);

		button1.setOnClickListener((OnClickListener) new writeOnClickListener());
		button2.setOnClickListener((OnClickListener) new fetchOnClickListener());
	}

	class writeOnClickListener implements OnClickListener {
		@Override
		public void onClick(View v) {
			int i = 0;
			try {
				i = IEEE1888WriteManager.ieee1888ClientWrite(
						"http://10.1.1.179:1888/IEEE1888Storage",
						"http://biigroup.com/room/2501/VA1",
						String.valueOf(Math.random()), Calendar.getInstance());
			} catch (Exception e) {
				e.printStackTrace();
			}
			System.out.print(i);
		}

	}

	class fetchOnClickListener implements OnClickListener {
		@Override
		public void onClick(View v) {
			String pointID[] = new String[1];
			pointID[0] = "http://biigroup.com/room/2501/VA1";
			PointDataStruct[] pd;
			try {
				pd = IEEE1888FetchManager.ieee1888ClientFetch(
						"http://10.1.1.179:1888/IEEE1888Storage", pointID,
						LimitType.LIMITTYPE_MAX, "maximum");
				
				System.out.println(pd.length);
				for (PointDataStruct tpd : pd) {
					textView6.setText(tpd.getPointID());
					textView7.setText(W3CTimestamp.toString(tpd
							.getPointValueArray().get(0).getTime()));
					textView8.setText(tpd.getPointValueArray().get(0)
							.getValue());
				}

			} catch (Exception e) {
				e.printStackTrace();
			}

		}

	}

}
